Index: src/web10g-util.c
===================================================================
--- src/web10g-util.c	(revision 0)
+++ src/web10g-util.c	(revision 0)
@@ -0,0 +1,234 @@
+/* 
+ * A handful of functions to handle some web10g specific stuff
+ * 
+ * Author: Richard Sanger
+ * 
+ */
+
+/* 
+ * These are used to pass information between web10g_connection_from_socket 
+ * and getremote_callback. It would be nice if these were not globals.
+ */
+#include "web100srv.h"
+#include "logging.h"
+
+static struct sockaddr_storage local_name;
+static struct sockaddr_storage peer_name;
+static int connection_id;
+
+/**
+ * Callback function used by web10g_connection_from_socket, will set 
+ * connection_id if the correct connection is found.
+ * 
+ * @param ct A tuple containing connection information
+ */
+static void fromsocket_callback(struct tcpe_connection_tuple* ct){
+  
+  /* I'm assuming local_name and remote_name should both be on
+   * the same addressing scheme i.e. either IPv4 or IPv6 not a mix of both */
+
+  if(local_name.ss_family == AF_INET && peer_name.ss_family == AF_INET){
+    /* We are IPv4 check if this web10g connection also is */
+    if((ct->local_addr[16]) == TCPE_ADDRTYPE_IPV4 
+      && (ct->rem_addr[16]) == TCPE_ADDRTYPE_IPV4){
+      
+      struct sockaddr_in * ipv4_local = (struct sockaddr_in *) &local_name;
+      struct sockaddr_in * ipv4_peer = (struct sockaddr_in *) &peer_name;
+        
+      /* Compare local and remote ports and addresses */
+      if(ct->local_port == ntohs(ipv4_local->sin_port) &&
+        ct->rem_port == ntohs(ipv4_peer->sin_port) &&
+        ((struct in_addr *) ct->rem_addr)->s_addr == ipv4_peer->sin_addr.s_addr &&
+        ((struct in_addr *) ct->local_addr)->s_addr == ipv4_local->sin_addr.s_addr ){
+        
+        /* Found it */
+        connection_id = ct->cid;
+        log_println(2, "Matched socket to web10g IPv4 connection #%d", connection_id);
+      }        
+    }
+  } else if(local_name.ss_family == AF_INET6){
+    /* We are IPv6 check if this web10g connection also is */
+    if((ct->local_addr[16]) == TCPE_ADDRTYPE_IPV6 
+      && (ct->rem_addr[16]) == TCPE_ADDRTYPE_IPV6){
+      
+      struct sockaddr_in6 * ipv6_local = (struct sockaddr_in6 *) &local_name;
+      struct sockaddr_in6 * ipv6_peer = (struct sockaddr_in6 *) &peer_name;
+      
+      /* Compare local and remote ports and addresses */
+      if(ct->local_port == ntohs(ipv6_local->sin6_port) &&
+        ct->rem_port == ntohs(ipv6_peer->sin6_port) &&
+        memcmp(ct->rem_addr, ipv6_peer->sin6_addr.s6_addr, sizeof(struct in6_addr)) == 0 &&
+        memcmp(ct->local_addr, ipv6_local->sin6_addr.s6_addr, sizeof(struct in6_addr)) == 0){
+        
+        /* Found it */
+        connection_id = ct->cid;
+        log_println(2, "Matched socket to web10g IPv6 connection #%d", connection_id);
+      }  
+    }
+  }
+}
+
+/**
+ * Find the web100 connection number related to a given socket.
+ * 
+ * @param client A web10g client
+ * @param sockfd The socket file descriptor
+ * 
+ * @return The connection number if successful. If an error occurs -1 
+ * will be returned.
+ * 
+ */
+int web10g_connection_from_socket(struct tcpe_client * client,int sockfd){
+  socklen_t local_name_len; 
+  socklen_t peer_name_len;
+  
+  local_name_len = sizeof(local_name);
+  peer_name_len = sizeof(peer_name);
+  connection_id = -1;
+
+  /* Get the ip address of ourself on the localsocket */
+  if (getsockname(sockfd,(struct sockaddr *) &local_name, &local_name_len) == -1) {
+    log_println(1, "getsockname() failed: %s ", strerror(errno));
+    return -1;
+  }
+
+  /* Get the ip address of our peer */
+  if (getpeername(sockfd,(struct sockaddr *) &peer_name, &peer_name_len) == -1) {
+    log_println(1, "getpeername() failed: %s ", strerror(errno));
+    return -1;
+  }
+  
+  tcpe_list_conns(client, fromsocket_callback);
+  
+  return connection_id;
+}
+
+/**
+ * Find the specified web10g variable given a connection at the current
+ * time.
+ * Similar to web10g_find_val except this also retrieves data from web10g
+ * rather than from a provided capture. If many varibles are being read
+ * it's probably best to capture the data then use web10g_find_val.
+ * 
+ * @param data A web10g data capture
+ * @param name The web10g variable name
+ * @param *value A pointer to a web10g value structure. If successful
+ *  this will contain the requested value upon return. If an error occurs
+ *  it's contents will remain untouched.
+ * 
+ * @return int 0 if successful otherwise 1 in the event of an error
+ * (including the case the specified value cannot be found).
+ * 
+ */
+int web10g_get_val(struct tcpe_client * client, int conn, char * name, struct tcpe_val * value){
+  int i;
+  tcpe_data* data = NULL;
+  
+  tcpe_data_new(&data);
+  tcpe_read_vars(data, conn, client);
+  
+  for (i = 0; i < ARRAYSIZE(data->val); i++){ 
+    if (data->val[i].mask) continue;
+  
+    if (strcmp(tcpe_var_array[i].name, name) == 0){
+            value->uv64 = data->val[i].uv64;
+      value->mask = data->val[i].mask;
+      i = -1;
+      break;
+    }
+  }
+  
+  tcpe_data_free(&data);
+  if(i == -1)
+    return 1;
+  else
+    return 0;
+}
+
+/* 
+ * These are used to pass information between web10g_get_remote_addr 
+ * and getremotecallback. It would be nice if these were not globals.
+ */
+static int connid;
+static char * remote_name;
+static int remote_name_size;
+
+/**
+ * Callback function used by web10g_get_remote_addr, will fill in 
+ * remote_name once if the correct connection is found and set remote_name
+ * to NULL to indicate to web10g_get_remote_addr that the connection was 
+ * found.
+ * 
+ * @param ct A tuple containing connection information
+ * 
+ */
+static void getremote_callback(struct tcpe_connection_tuple* ct){
+  if( ct->cid == connid && ct->local_addr[16] == TCPE_ADDRTYPE_IPV4){
+    inet_ntop(AF_INET, &(ct->rem_addr[0]), remote_name, remote_name_size);
+    remote_name = NULL;
+  } else if( ct->cid == connid && ct->local_addr[16] == TCPE_ADDRTYPE_IPV6){
+    inet_ntop(AF_INET6, &(ct->rem_addr[0]), remote_name, remote_name_size);
+    remote_name = NULL;
+  }
+}
+
+/**
+ * Get the remote address given connection number
+ * 
+ * @param client Web10g client
+ * @param conn The web10g connection number
+ * @param out A pointer to a character buffer, into which the remote 
+ *  address will be returned if successful. Upon error the contents are
+ *  remain unchanged.
+ * @param size The size of the buffer 'out'.
+ * 
+ * @return int 0 if successful otherwise 1 in the event of an error
+ * (The connection could not be found).
+ * 
+ */
+int web10g_get_remote_addr(struct tcpe_client * client, int conn, char * out, int size){
+  /* Pass these to the callback routine using those globals */
+  connid = conn;
+  remote_name = out;
+  remote_name_size = size;
+  /* This will call the getremote_callback once for every tcp connection */
+  tcpe_list_conns(client, getremote_callback);
+  
+  if(remote_name == NULL)
+    return 0;
+  else
+    return 1;
+}
+
+/**
+ * Find the specified web10g variables value within a provided capture.
+ * Similar to web10g_get_val except this works on a previously retrieved
+ * set of data.
+ * 
+ * @param data A web10g data capture
+ * @param name The web10g variable name
+ * @param *value A pointer to a web10g value structure. If successful
+ *  this will contain the requested value upon return. If an error occurs
+ *  its contents will remain untouched.
+ * 
+ * @return int 0 if successful otherwise 1 in the event of an error
+ * (including the case the specified value cannot be found).
+ * 
+ */
+int web10g_find_val(tcpe_data* data, char * name, struct tcpe_val * value){
+  int i;
+  
+  if(data == NULL || name == NULL || value == NULL)
+    return 1;
+
+  for (i = 0; i < ARRAYSIZE(data->val); i++){ 
+    if (data->val[i].mask) continue;
+    if (strcmp(tcpe_var_array[i].name, name) == 0){
+      value->uv64 = data->val[i].uv64;
+      value->mask = data->val[i].mask;
+      return 0;
+    }
+  }
+  
+  return 1;
+}
Index: src/web100clt.c
===================================================================
--- src/web100clt.c	(revision 796)
+++ src/web100clt.c	(working copy)
@@ -19,6 +19,8 @@
 #include "clt_tests.h"
 #include "strlutils.h"
 #include "test_results_clt.h"
+#include <arpa/inet.h>
+#include <assert.h>
 
 extern int h_errno;
 
@@ -237,6 +239,29 @@
 }
 
 /**
+ * Get a string representation of an ip address.
+ * 
+ * @param addr A sockaddr structure which contains the address
+ * @param buf A buffer to fill with the ip address as a string
+ * @param len The length of buf.
+ */
+static void addr2a(struct sockaddr_storage * addr,char * buf, int len){
+  
+  if(((struct sockaddr *)addr)->sa_family == AF_INET){
+    /* IPv4 */
+    inet_ntop(AF_INET, &(((struct sockaddr_in *)addr)->sin_addr),
+                    buf, len);
+  }
+#ifdef AF_INET6 
+  else if(((struct sockaddr *)addr)->sa_family == AF_INET6 ){
+    /* IPv6 */
+    inet_ntop(AF_INET6, &(((struct sockaddr_in6 *)addr)->sin6_addr),
+                    buf, len);
+  }
+#endif
+}
+
+/**
  * This routine decodes the middlebox test results.  The data is returned
  * from the server in a specific order.  This routine pulls the string apart
  * and puts the values into the proper variable.  It then compares the values
@@ -247,14 +272,14 @@
  * Client then adds
  * Server IP; Client IP.
  * @param midresult_str  String containing test results
- * @param local_addr Client IP address
- * @param peer_addr  Server IP address
+ * @param cltsock Used to get address information
  */
 
-void middleboxResults(char *midresult_str, I2Addr local_addr,
-                      I2Addr peer_addr) {
+void middleboxResults(char *midresult_str, int cltsock) {
   char ssip[64], scip[64], *str;
   char csip[64], ccip[64];
+  struct sockaddr_storage addr;  
+  socklen_t addr_size;
   int mss;
   size_t tmpLen;
 
@@ -271,14 +296,27 @@
   winssent = atoi(str);
   str = strtok(NULL, ";");
   winsrecv = atoi(str);
-
-  memset(ccip, 0, 64);
+  
+  /* Get the our local ip address */
+  addr_size = sizeof(addr);
+  memset(csip, 0, 64);
   tmpLen = 63;
-  I2AddrNodeName(local_addr, ccip, &tmpLen);
+  if (getsockname(cltsock,(struct sockaddr *) &addr, &addr_size) == -1) {
+    perror("Middlebox - getsockname() failed");
+  } else {
+    addr2a(&addr, ccip , tmpLen);
+  }
+  
+  /* Get the Server ip address */
+  addr_size = sizeof(addr);
   memset(csip, 0, 64);
   tmpLen = 63;
-  I2AddrNodeName(peer_addr, csip, &tmpLen);
-
+  if (getpeername(cltsock,(struct sockaddr *) &addr, &addr_size) == -1) {
+    perror("Middlebox - getpeername() failed");
+  } else {
+    addr2a(&addr, csip , tmpLen);
+  }
+  
   // Check if MSS modification is happening
   check_MSS_modification(TimestampsEnabled, &mss);
 
@@ -486,7 +524,6 @@
   int testId;  // test ID received from server
   // addresses..
   I2Addr server_addr = NULL;
-  I2Addr local_addr = NULL, remote_addr = NULL;
   char* ptr;
 #ifdef AF_INET6
 #define GETOPT_LONG_INET6(x) "46"x
@@ -854,9 +891,7 @@
     log_println(6, "resultstr = '%s'", resultstr);
   }
 
-  local_addr = I2AddrByLocalSockFD(get_errhandle(), ctlSocket, False);
-  remote_addr = I2AddrBySockFD(get_errhandle(), ctlSocket, False);
-  I2AddrFree(server_addr);
+  
 
   strlcpy(varstr, resultstr, sizeof(varstr));
   // print test results
@@ -864,9 +899,11 @@
 
   // print middlebox test results
   if (tests & TEST_MID) {
-    middleboxResults(mid_resultstr, local_addr, remote_addr);
+    middleboxResults(mid_resultstr, ctlSocket);
   }
-
+  
+  I2AddrFree(server_addr);
+  
   // print extra information collected from web100 variables
   if ((tests & TEST_S2C) && (msglvl > 1))
     printVariables(varstr);
Index: src/test_meta_srv.c
===================================================================
--- src/test_meta_srv.c	(revision 796)
+++ src/test_meta_srv.c	(working copy)
@@ -22,7 +22,7 @@
 /**
  * Performs the META test.
  * @param ctlsockfd Client control socket descriptor
- * @param agent Web100 agent used to track the connection
+ * @param not_usedagent Web100 agent or tcpe client used to track the connection not used
  * @param testOptions The test options
  * @param conn_options The connection options
  * @return 0 - success,
@@ -38,7 +38,7 @@
  *			4 - Invalid data format in received message
  */
 
-int test_meta_srv(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_meta_srv(int ctlsockfd, tcp_stat_agent not_usedagent, TestOptions* testOptions,
                   int conn_options) {
   int j;
   int msgLen, msgType;
Index: src/web100-admin.c
===================================================================
--- src/web100-admin.c	(revision 796)
+++ src/web100-admin.c	(working copy)
@@ -17,6 +17,7 @@
 #include "web100-admin.h"
 #include "utils.h"
 #include "strlutils.h"
+#include "heuristics.h"
 
 /* Initialize the Administrator view.  Process the data in the existing log file to
  * catch up on what's happened before.
Index: src/tests_srv.h
===================================================================
--- src/tests_srv.h	(revision 796)
+++ src/tests_srv.h	(working copy)
@@ -11,19 +11,15 @@
 
 #include "testoptions.h"
 
-int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_c2s(int ctlsockfd, tcp_stat_agent agent, TestOptions* testOptions,
              int conn_options, double* c2sspd, int set_buff, int window,
              int autotune, char* device, Options* options, int record_reverse,
              int count_vars, char spds[4][256], int* spd_index);
-
-// S2C test
-int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_s2c(int ctlsockfd, tcp_stat_agent agent, TestOptions* testOptions,
              int conn_options, double* s2cspd, int set_buff, int window,
              int autotune, char* device, Options* options, char spds[4][256],
              int* spd_index, int count_vars, CwndPeaks* peaks);
-
-// the middlebox test
-int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_mid(int ctlsockfd, tcp_stat_agent agent, TestOptions* testOptions,
              int conn_options, double* s2c2spd);
 
 #endif  // SRC_TESTS_SRV_H_
Index: src/kernel_config.c
===================================================================
--- src/kernel_config.c	(revision 0)
+++ src/kernel_config.c	(revision 0)
@@ -0,0 +1,250 @@
+/* 
+ * This contains functions used by ndt to tweak kernel settings.
+ * This uses the /proc/sys interface.
+ * 
+ * Author: Richard Sanger
+ */
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include "logging.h"
+
+/* Storage for the congestion control method */
+static char oldCongestionControl[128];
+
+/* The name for reno that we write to the proc interface */
+#define RENO "reno"
+
+/** 
+ * Reverses swap_to_reno by changing the congestion control to what
+ * it was before swap_to_reno was called. 
+ * 
+ * @return 0 if successfully otherwise -1
+ */
+int revert_congestion(){
+  FILE *fdwrite;
+  size_t len;
+
+  /* Check if we need to change it back */
+  if(oldCongestionControl[0] != 0){
+    fdwrite = fopen("/proc/sys/net/ipv4/tcp_congestion_control", "w");
+    if(fdwrite == NULL){
+      log_println(0, "tcp_congestion_control Cannot open file for writing"
+          " - probably need to be super user: %s", strerror(errno));
+      return -1;
+    }
+    /* Write the original value back to tcp_congestion_control */
+    len = fwrite(oldCongestionControl, sizeof(char), strlen(oldCongestionControl), fdwrite);
+    if(len != strlen(oldCongestionControl)){
+      log_println(0, "tcp_congestion_control Write failed: %s", 
+        strerror(errno));
+      fclose(fdwrite);
+      return -1;
+    }
+    if (fclose(fdwrite)){
+      log_println(0, "tcp_congestion_control Write failed: %s", 
+        strerror(errno));
+      return -1;
+    }
+    oldCongestionControl[0] = 0;
+    log_println(6, "Successfully reverted tcp_congestion_control to its original value");
+  }
+  return 0;
+}
+
+/** 
+ * Swaps the kernel to reno tcp congestion control. The man pages say
+ * that reno is a guaranteed tcp congestion control on every linux 
+ * system.
+ * @param autofix if not 0 this function will try and change the settings
+ * 
+ * @return 0 if successfully otherwise -1
+ */
+int check_kernel(int autofix){
+  FILE *fdread, *fdwrite;
+  size_t len;
+  fdwrite = fdread = NULL; 
+  
+  /* Try read the current value, if it is already reno we don't need to change it */
+  fdread = fopen("/proc/sys/net/ipv4/tcp_congestion_control", "r");
+  if(fdread == NULL){
+    log_println(0, "tcp_congestion_control Cannot open file for reading: %s", 
+        strerror(errno));
+    goto error_handle;
+  }
+  /* Store the current value into oldCongestionControl */
+  len = fread((void *)oldCongestionControl, sizeof(char), sizeof(oldCongestionControl), fdread);
+  if(!feof(fdread)){
+    log_println(0, "tcp_congestion_control fread failed: %s", 
+        strerror(errno));
+    goto error_handle;
+  } else {
+    fclose(fdread);
+    fdread = NULL;
+  }
+
+  if(len == sizeof(oldCongestionControl)){
+    log_println(0, "ERROR original congestion control string is to long");
+    goto error_handle;
+  } else {
+    /* Null terminate */
+    oldCongestionControl[len] = 0;
+  }
+  
+  /* Check if it's already reno */
+  if(strncmp(RENO, oldCongestionControl, sizeof(RENO)-1) == 0){
+    log_println(6, "Tcp_congestion_control value is already reno no change needed");
+    oldCongestionControl[0] = 0;
+    return 0;
+  }
+  
+  log_println(6, "The original tcp_congestion_control value is %s", 
+    oldCongestionControl);
+
+  /* We need to change to reno */
+  if(!autofix){
+    log_println(0, "Warning: tcp_congestion_control should be set to '"
+    RENO "' ndt results may be incorrect");
+    oldCongestionControl[0] = 0;
+    return 0;
+  } 
+  
+  fdwrite = fopen("/proc/sys/net/ipv4/tcp_congestion_control", "w");
+  if(fdwrite == NULL){
+    log_println(0, "Tcp_congestion_control fopen(write) - probably not super user: %s", strerror(errno));
+    goto error_handle;
+  }
+  len = fwrite(RENO,sizeof(char), sizeof(RENO)-1, fdwrite);
+  if(len != sizeof(RENO)-1){
+    log_println(0, "Tcp_congestion_control fwrite: %s", strerror(errno));
+    goto error_handle;
+  }
+  if (fclose(fdwrite)){
+    if(errno == ENOENT){
+      /* Trying to set a bad value will give us this error */
+      log_println(0, "'" RENO "' tcp congestion control not available"
+        " on this system??: %s", strerror(errno));
+    } else {
+      log_println(0, "tcp congestion control fclose(fdwrite): %s", strerror(errno));
+    }
+    goto error_handle;
+  }
+  /* Success - Kernel has accpected and changed to reno */
+  log_println(6, "Successfully changed tcp_congestion_control to " RENO);
+  return 0;
+  
+  /* Print warnings and close all the file handles if and error occurs */
+error_handle:
+  /* We have failed reading */
+  if(fdread == NULL && fdwrite == NULL){
+    log_println(0, "Warning: Could not determine current tcp_congestion_control" 
+    ", this should be set to 'reno' or else ndt results may be incorrect.");
+    oldCongestionControl[0] = 0;
+    return -1;
+  }
+  /* Set close the read handle if its still open */
+  if(fdread != NULL){
+    fclose(fdread);
+    fdread = NULL;
+  }
+  /* We have failed writing */
+  if(fdwrite != NULL){
+    fclose(fdwrite);
+    fdwrite = NULL;
+    return -1;
+  }
+  oldCongestionControl[0] = 0;
+  log_println(0, "Warning: Failed to change congestion tcp_congestion_control to '"
+    RENO "' ndt results may be incorrect");
+  return -1;
+}
+
+
+static char module_already_loaded = 1;
+#define TCP_ESTATS_MODULE "tcp_estats_nl"
+
+/**
+ * Search for the TCP_ESTATS_MODULE in /proc/module aka the list of 
+ * running modules
+ * 
+ * @return 0 not running, 1 running, -1 error.
+ */
+static int search_for_module_tcpe(){
+  int loaded = 0;
+  FILE *mods_fd;
+  char buf[256];
+  mods_fd = fopen("/proc/modules", "r");
+  
+  if(mods_fd == NULL){
+    log_println(0, "/proc/modules Cannot open file for reading: %s", 
+        strerror(errno));
+    return -1;
+  }
+  
+  /* Search for the tcp_estats module line */
+  while(fgets(buf, 256, mods_fd)){
+    if(strncmp(TCP_ESTATS_MODULE " ", buf , sizeof(TCP_ESTATS_MODULE " ") - 1)
+                == 0){
+      loaded = 1;
+      break;
+    }
+  }
+  
+  fclose(mods_fd);
+  return loaded;
+}
+
+/**
+ * Check if tcp_estats module is loaded and will load if not. (Only 
+ * relevent to web10G)
+ * 
+ * @return 0 on success, -1 upon failure either to load the module or 
+ * determine if the module is running.
+ */
+int start_tcpe(){
+  int code = search_for_module_tcpe();
+  
+  if(code == -1)
+    return -1;
+
+  if(code == 1){
+    module_already_loaded = 1;
+    return 0;
+  }
+  module_already_loaded = 0;
+  /* Module is not loaded try and load it */
+  log_println(1, "Warning: tcp_estats module not loaded, attempting to load");
+  system("modprobe " TCP_ESTATS_MODULE );
+  if(search_for_module_tcpe() == 1)
+    return 0;
+  
+  log_println(0, "Error: tcp_estats module could not be loaded");
+  return -1;
+}
+
+/**
+ * Unload tcp_estats module if it was previously unloaded (Only 
+ * relevent to web10G). If the module was previously loaded 
+ * success code is returned and this function does nothing.
+ * 
+ * Only should be called after start_tcpe().
+ * 
+ * @return 0 on success, -1 upon failure either to unload the module.
+ */
+int revert_tcpe(){
+  if( module_already_loaded )
+    return 0;
+  
+  /* We had to load the module so unload it*/
+  log_println(1, "Warning: tcp_estats needs to be unloaded, attempting to unload");
+  system("modprobe -r " TCP_ESTATS_MODULE );
+  if( search_for_module_tcpe() == 0){
+    log_println(1, "Successfully unloaded tcp_estats ");
+    return 0;
+  }
+  
+  log_println(0, "Warning: tcp_estats failed to unload  '");
+  return -1;
+}
+
